var driveList = document.getElementById('driveList');

function init() {
	detectDrives();
	System.Gadget.Flyout.file = 'info.html';
	System.Gadget.settingsUI = 'settings.html';
	System.Gadget.onSettingsClosed = SettingsClosed;
}

function SettingsClosed() {
    refresh();
}

function refresh() {
    driveList.options.length = 0; 
	detectDrives();
}

function showDriveInfo() {
   System.Gadget.Flyout.show = true;
}

function updateDriveSelected() {
    driveList = document.getElementById('driveList');
    driveLetterSelected = driveList.options[driveList.selectedIndex].text;
	driveTypeSelected = driveList.options[driveList.selectedIndex].driveType;
	System.Gadget.Settings.write('driveLetter', driveLetterSelected);
	
	if (driveTypeSelected == 2) {
	    document.getElementById('closeButton').value = 'Browse';
		closeOrBrowse = 'Browse';
		System.Gadget.Settings.write('driveDescription', 'Removable')
		
	}
	else if (driveTypeSelected == 3) {
	    document.getElementById('closeButton').value = 'Browse';
		closeOrBrowse = 'Browse';
		System.Gadget.Settings.write('driveDescription', 'Fixed')
	}
	else if (driveTypeSelected == 5) {
	    document.getElementById('closeButton').value = 'Close';
		closeOrBrowse = 'Close';
		System.Gadget.Settings.write('driveDescription', 'Optical')
	}
}

function ejectDrive() {
    if (driveTypeSelected == 5) {
	    System.Shell.execute(System.Gadget.path + '\\data\\Run', 'CD_DVD_Drive_Eject open ' + driveLetterSelected);
	}else{
	    System.Shell.execute(System.Gadget.path + '\\data\\USB_Disk_Eject', '/SHOWEJECT /REMOVELETTER ' + driveLetterSelected);
		setTimeout('refresh()',2500);
	}
}

function closeOrBrowseDrive() {
    if (closeOrBrowse == 'Close') {
        System.Shell.execute(System.Gadget.path + '\\data\\Run', 'CD_DVD_Drive_Eject close ' + driveLetterSelected);
	}
	else if (closeOrBrowse == 'Browse') {
	    System.Shell.execute(driveLetterSelected + '\\');
	}
}


function addOption(driveLetter, driveType)
{
	var optn = document.createElement("OPTION");
	optn.text = driveLetter;
	optn.driveType = driveType;
	var driveList = document.getElementById("driveList").options.add(optn);
}

function detectDrives() {
    var allDriveLetters = new Array("A:","B:","C:","D:","E:","F:","G:","H:","I:","J:","K:","L:","M:","N:","O:","P:","Q:","R:","S:","T:","U:","V:","W:","X:","Y:","Z:");
    for (i = 0; i<allDriveLetters.length; i++) {
	shellDrive = System.Shell.drive(allDriveLetters[i]);
	    try {
			if(shellDrive.isReady && (shellDrive.driveType == 2)) {
			    addOption(allDriveLetters[i], shellDrive.driveType);
			}
			
			if(System.Gadget.Settings.read('showFixedDrives') == true && (shellDrive.driveType == 3)) {
			    addOption(allDriveLetters[i], shellDrive.driveType);
			}
			
			if(shellDrive.driveType == 5) {
			    addOption(allDriveLetters[i], shellDrive.driveType);
			}
		}
		catch(e) {
            continue;
        }
    }
	updateDriveSelected()
}